/**
 * @jQueryPlugin scrollbox
 *    Creates a custom scrollbar on an element that is consistent across browsers, and is WCAG 2.0 compliant
 * @author marcnewport@gmail.com
 * @dependencies jQuery
 * @license GPLv2
 */
!function(e){e.fn.scrollbox=function(o){return this.each(function(){o=o||{};var t=e(this),n=0,r=[],a=0,i=[],l=[],s=[],c=[],d=0,u=0,f=false,h=0,m=false,v={};v.init=function(){n=t.width();r=t.height();i=e(document.createElement("div")).addClass("scrollbox-content");l=e(document.createElement("div")).addClass("scrollbox-track");s=e(document.createElement("div")).addClass("scrollbox-handle");c=e(document);t.wrapInner(i);t.bind("heightChange",v.decide);v.decide()};v.decide=function(){var e=0;i=t.find(".scrollbox-content");h=i.scrollTop();e=i.get(0).scrollHeight;a=i.attr("style","width:"+(n-20)+"px").height();if(e>r)v.setup();else v.disable()};v.setup=function(){var n={},c={},m={},p=0;n={overflow:"hidden",position:"relative"};t.addClass("jquery-scrollbox").attr("tabindex",0).css(n);c={border:"1px solid #000000",width:"8px",height:r-2+"px",position:"absolute",top:"0",right:"0",borderRadius:"5px",opacity:.3};e.extend(c,o.track);l.css(c);d=Math.floor(100*(r/a));u=Math.round(d/100*r);if(u<16)u=16;m={background:"#000000",width:"8px",height:u+"px",cursor:"pointer",borderRadius:"4px",transition:"margin 85ms"};e.extend(m,o.handle);s.css(m);i.css({position:"relative",overflow:"hidden",height:r+"px",transition:"margin 85ms"});t.append(l.append(s));if(f){p=Math.floor(100*(h/(a-r)));v.scroll(p)}else v.scroll(0);if("ontouchstart"in window)i.get(0).addEventListener("touchstart",v.touchpadDragHandler,false);t.bind("mouseover",v.mouseoverHandler);t.bind("mouseout",v.mouseoutHandler);t.bind("DOMMouseScroll mousewheel",v.mousewheelMoveHandler);s.bind("mousedown",v.scrollbarDragHandler);t.bind("focus.scrollbox",v.focusHandler);l.bind("click.track",v.trackClickHandler);f=true};v.mouseoverHandler=function(){l.stop().animate({opacity:.5},200)};v.mouseoutHandler=function(){l.stop().animate({opacity:.3},200)};v.mousewheelMoveHandler=function(e){var o=e.originalEvent.detail,t=o>0?15:-15,n=0,l=0;if(e.originalEvent.deltaY)t=e.originalEvent.deltaY;n=i.scrollTop()+t;if(t<0)l=Math.floor(100*(n/(a-r)));else l=Math.ceil(100*(n/(a-r)));v.scroll(l);e.preventDefault()};v.scrollbarDragHandler=function(o){var t=o.pageY,n=0,a=parseInt(e(this).css("margin-top"),10),i=0,l=0,s=function(){return false};m=true;c.bind("mousemove",function(e){n=e.pageY;i=a+Math.floor(n-t);l=100*(i/(r-u));v.scroll(l);if(void 0!==document.attachEvent)document.attachEvent("onselectstart",s)}).mouseup(function(){c.unbind("mousemove");if(void 0!==document.attachEvent)document.detachEvent("onselectstart",s);setTimeout(function(){m=false},100)}).find("body").mouseleave(function(){c.unbind("mousemove");setTimeout(function(){m=false},100)});return false};v.focusHandler=function(){var o=i.scrollTop(),n=0,s=a-r,c=true;e(document).bind("keydown.scrollbox",function(e){switch(e.which){case 33:o-=120;break;case 34:o+=120;break;case 35:o=s;break;case 36:o=0;break;case 38:o-=15;c=false;break;case 40:o+=15;c=false;break;default:return}if(o<0)o=0;if(o>s)o=s;n=Math.round(100*(o/(a-r)));v.scroll(n,c);e.preventDefault()});l.stop().animate({opacity:.5},200);t.bind("blur.scrollbox",function(){e(document).unbind("keydown.scrollbox");t.unbind("blur.scrollbox");l.stop().animate({opacity:.3},200)})};v.trackClickHandler=function(e){var o=0,t=0;if(!m){o=e.pageY-l.offset().top;t=Math.floor(100*(o/l.height()));v.scroll(t,true)}};v.touchpadDragHandler=function(e){e=e||window.event;var o=e.touches[0].pageY,t=0,n=parseInt(s.css("margin-top"),10),a=0,l=0,c=function(){},d=function(){};c=function(s){s=s||window.event;if(s.touches.length>1){i.get(0).removeEventListener("touchmove",c,false);return}s.preventDefault();t=s.touches[0].pageY;a=n-Math.floor(t-o);l=100*(a/(r-u));v.scroll(l);e.cancelBubble=true;if(e.stopPropagation)e.stopPropagation()};d=function(e){if(!e)e=window.event;e.cancelBubble=true;if(e.stopPropagation)e.stopPropagation();i.get(0).removeEventListener("touchmove",c,false);i.get(0).removeEventListener("touchend",d,false)};i.get(0).addEventListener("touchmove",c,false)};v.scroll=function(e,o){var t=0,n=0,l=0,c=0;if(e<0)e=0;else if(e>100)e=100;t=a-r;n=Math.floor(t*(e/100));if(n<0)n=0;else if(n>t)n=t;if(o)i.animate({scrollTop:n},16);else i.scrollTop(n);l=r-u-2;c=Math.floor(l*(e/100));if(c<0)c=0;else if(c>l)c=l;if(e<1)c=0;if(o)s.animate({marginTop:c},16);else s.css("margin-top",c+"px")};v.disable=function(){t.attr("style","overflow:hidden").removeClass("jquery-scrollbox");i.removeAttr("style");l.removeAttr("style");s.removeAttr("style");t.unbind("mousewheel");s.unbind("mousedown");c.unbind("mousemove");if("ontouchstart"in window)i.get(0).removeEventListener("touchstart",v.touchpadDragHandler,false)};v.destroy=function(){var o=t.find(".scrollbox_content").html();t.removeClass("scrollbox").attr("style","overflow:hidden");t.find(".scrollbox_content").remove();t.html(o);t.find(".track").remove();t.find(".handle").remove();t.unbind("mousewheel");e(document).unbind("mousemove")};switch(typeof o){case"object":v.init.call();break;case"string":if(v[o])v[o].call();else e.error("scrollbox does not recognise the method "+o);break;default:e.error("scrollbox does not recognise the parameter "+o)}})}}(jQuery);
